#!/usr/bin/perl

# program to compare rpm versions.
# requires two arguments, the package base name without version and
# the full name (with version).

$argc = scalar(@ARGV);

$basename = $ARGV[0];
$newfullname = $ARGV[1];

# strip .ix86.rpm

$newfullname =~ s/\.i.86\.rpm//;

$len = length($basename);

$newversion = substr($newfullname, $len + 1, 999);

print("$basename newversion $newversion\n");

open(FD, "rpm -q $basename |");

$oldfullname = <FD>;
chomp($oldfullname);

close(FD);

if ($oldfullname eq "") {
	print("No previous package, fresh install\n");
	exit(0);
}

$oldversion = substr($oldfullname, $len + 1, 999);

print("$basename oldversion $oldversion\n");

@old = split("[-\.]", $oldversion);
@new = split("[-\.]", $newversion);

$omax = scalar(@old);
$nmax = scalar(@new);

$max = $omax;
if ($max < $nmax) {
	$max = $nmax;
}

for ($i = 0; $i < $max; $i++) {
	if ($i eq $omax) {
		print("Update recommended\n");
		exit(0);
	}
	if ($i eq $nmax) {
		print("No update needed\n");
		exit(1);
	}
	$oldone = $old[$i];
	$newone = $new[$i];
	# must support both ascii and integer comparisons
	# if either is not digits then we use ascii.
	$useascii = 0;
	if ($oldone =~ /[^0-9]/) {
		$useascii = 1;
	}
	if ($newone =~ /[^0-9]/) {
		$useascii = 1;
	}
	if ($useascii == 0) {
		if ($newone > $oldone) {
			print("Update recommended\n");
			exit(0);
		}
		if ($newone < $oldone) {
			print("No update needed\n");
			exit(1);
		}
	} else {
		if ($newone gt $oldone) {
			print("Update recommended\n");
			exit(0);
		}
		if ($newone lt $oldone) {
			print("No update needed\n");
			exit(1);
		}
	}
}

print("No update needed, same version\n");
exit(1);
