<?php
/*
 * Copyright (C) 2001-2002 Caldera International, Inc.  All Rights Reserved.
 */

class FileProgList extends ObjectTable {
	
	var $alias;

	function FileProgList($aliasObj, $varArray, $id) {


		if ($aliasObj == '') {
			$this = '';
			return;
		} else {
			$this->alias = $aliasObj;
		}

		if ($this->alias->files) foreach ($this->alias->files as $m) {
			$this->list[] = new MemberFactory('file', $m);
		}
		if ($this->alias->programs) foreach ($this->alias->programs as $m) {
			$this->list[] = new MemberFactory('program', $m);
		}

		// Setup the table
		if (Table::isActive($varArray, $id)) {
			$table = Table::getActive();
			$table->setParams($varArray, $this->count());

			$this->setActionExtra('&mail=' . 
				rawurlencode($this->alias->mail));
		} else {
			$table = new Table($id);

			$name = getIntlMsg('MSG_MEMBERS_HEADING_FILEPROG');
			$table->addDataColumn($name, Column::ASCEND(),
				'id');

			$name = getIntlMsg('MSG_MEMBERS_HEADING_CLASS');
			$table->addDataColumn($name, Column::ASCEND(),
				'class');

			if (isAdmin()) {
			$name = getIntlMsg('MSG_MEMBERS_HEADING_REMOVE');
			$table->addDisplayColumn($name,
				"return Go('aliasremovefileprog_action.php?" .
				"%%ROWID%%')");
			}

			$table->setParams($HTTP_GET_VARS, $this->count());
			$table->rows = $GLOBALS['MEMBERS_TABLE_ROWS'];
			$table->setSortedColumn($table->firstSortedColumn());

			$this->setActionExtra('&mail=' . 
				rawurlencode($this->alias->mail));
		}

		// Apply sorting
		$attr = $table->getSortAttrName($table->getSortedColumn());
		$dir  = $table->getColumnSortDir($table->getSortedColumn());
		$this->sort(Member::comparisonFunctionName($attr ,$dir));

		// Save table
		$this->table = $table;
		$this->table->save();
	}


	function getListValue($index, $col = '') {
		global $session_lang;

		// if no $col then return the row value (unique id)
		if ($col === '') {
			$retval  = "mail=" . rawurlencode($this->alias->mail);
			$retval .= "&_type=" . strtolower($this->list[$index]->class);
			$retval .= "&_fileprog=" . rawurlencode($this->list[$index]->id);
			return $retval;
		}

		$mgeneric = $this->list[$index];
		$class = get_class($mgeneric);

		switch ($col) {
			case '0':
			case 'id':
				$retval = $mgeneric->getId();
				if (strlen($retval) > 50) {
					$retval  = substr($retval, 0, 50);
					$retval .= '...';
				}
				$retval = '<a href="#"' . 
					' onClick="return Go(\'' .
					'aliasmodifyfileprog.php' .
					'?mail=' . 
					rawurlencode($this->alias->mail) .
					'&_type=' .
					strtolower($mgeneric->getClassId()) .
					'&_fileprog=' .
					rawurlencode($mgeneric->getId()) .
					'\')">' .
					$retval . '</a>';
				
				break;
			case '1':
			case 'class':
				$retval = $mgeneric->getClass();
				break;
			case '2' :
				$retval = $this->table->getTemplate('deleteIcon');
				$retval = ereg_replace('%%LANG%%', $session_lang, $retval);
				$retval = stripslashes($retval);
				break;
			default:
				$retval = '';
				break;
		}

		return $retval;
	}

	function getNav() {
		global $_SELF, $_SERIAL;
	
		$current = (int)($this->table->offset / $this->table->rows) + 1;

		$total = (int)($this->count() / $this->table->rows);
		if ($this->count() % $this->table->rows > 0) {
			$total++;
		} elseif ($this->count() == 0) {
			$total = 1;
		}
	
		$retval = '<div class="tablenav">';
		$retval .= getIntlMsg('MSG_TABLE_CURRENT_PAGE',
			   $current, $total);
		if ($total == 1) {
			return $retval;
		}
 		$retval .= ' ' . getIntlMsg('MSG_TABLE_CURRENT_SEP') . ' ';
		if ($current > 1) {
			$offset = ($current - 2) * $this->table->rows;
			$href = $_SELF .
				'?mail='   . $this->alias->mail .
				'&offset=' .  $offset .
				'&serial=' . $_SERIAL;
			$retval .= ' <a href="' . $href . 
				 '" class="tablenav">' .
				getIntlMsg('MSG_TABLE_PAGE_PREV') . '</a> ';
		}
		for ($i = 1; $i <= $total; $i++) {
			$offset = ($i - 1) * $this->table->rows;
			$href = $_SELF .  
				'?mail=' . $this->alias->mail .
				'&offset=' . $offset .
				'&serial=' . $_SERIAL;
			if ($current != $i) {
				$retval .= ' <a href="' . $href . 
					'" class="tablenav">' . $i . '</a> ';
			} else {
				$retval .= " $i ";
			}
		}
		if ($current < $total) {
			$offset = ($current) * $this->table->rows;
			$href = $_SELF .  
				'?mail=' . $this->alias->mail . 
				'&offset=' . $offset .
				'&serial=' . $_SERIAL;
			$retval .= ' <a href="' . $href . 
				'" class="tablenav">' . 
				getIntlMsg('MSG_TABLE_PAGE_NEXT') . '</a> ';
		}
		$retval .= '</div>' . "\n";

		return $retval;

	}

}

?>
