<?php
/*
 * Copyright (C) 2001-2002 Caldera International, Inc.  All Rights Reserved.
 */

class MailAddress {
	var $mail;
	var $type;

	function MailAddress() {
		$numArgs = func_num_args();

		switch ($numArgs) {
		  case 0:
			$this->mail = '';
			break;
		  case 1:
			$this->_mailAddress(func_get_arg(0));
			break;
		  default:
			$this->mail = '';
			break;
		}
	}

	function _mailAddress($address) {
		global $session_domain;

		$pos = strpos($address, '@');
		if ($pos === false) {
			$address = $address . '@' . $session_domain;
		}
		$this->mail = $address;
		$this->type = $this->determineType($address);

		if (! $this->type) {
			$this = '';
		}
	}

	function stripLocalDomain() {
		global $session_domain;

		$mail = $this->mail;
		$domain = $session_domain;

		$numArgs = func_num_args();

		switch ($numArgs) {
		  case 1:
			$mail = func_get_arg(0);
			break;
		  case 1:
			$mail = func_get_arg(0);
			$domain = func_get_arg(1);
			break;
		  default:
			break;
		}

		$pos = strpos($mail, '@' . $domain);
		if ($pos !== false) {
			$mail = substr($mail, 0, $pos);
		}

		return $mail;
	}

	function isValid($address) {
	
		//if (ereg('^[^\(\)\<\>\@\,\;\:\\\"\.\[\] ]+[.[^\(\)\<\>\@\,\;\:\\\"\.\[\]]]*@[^\(\)\<\>\@\,\;\:\\\"\.\[\] ]+[.[^\(\)\<\>\@\,\;\:\\\"\.\[\]]]+$', $address)) {
		if (ereg('^[a-zA-Z0-9_.]+@[a-zA-Z0-9_.]+$', $address)) {
			return true;
		}
		return false;
	}

	function determineType($address) {
		global $session_domain;

		$remote = false;
		$pos = strpos($address, '@');
		if ($pos === false) {
			$remote = false;
			$address = $address . '@' . $session_domain;
		} elseif (substr($address, $pos + 1) == $session_domain) {
			$remote = false;
		} else {
			$remote = true;
		}

		if (! $this->isValid($address)) {
			return false;
		}

		if ($remote) {
			return 'remote';
		}

		// is it a user mail address
		$tmp = new User($address);
		unset($GLOBALS['LAST_ERROR']);
		if ($tmp && $tmp->mail == $address) {
			return 'user';
		} 

		// is it an alias mail address
		$tmp = new Alias($address);
		unset($GLOBALS['LAST_ERROR']);
		if ($tmp && $tmp->mail == $address) {
			return 'alias';
		}
	}
}
?>
